﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Collections;

namespace GroupRowCount
{
    public partial class WebForm1 : System.Web.UI.Page
    {       
        protected void Page_Load(object sender, EventArgs e)
        {
            if (IsPostBack)
                return;
          
            FpSpread1.Sheets[0].RowCount = 3;
            FpSpread1.Sheets[0].ColumnCount = 3;
            FpSpread1.Sheets[0].SetClip(0, 0, 1, 3, "James\tEngland\t10");
            FpSpread1.Sheets[0].SetClip(1, 0, 1, 3, "Peter\tEngland\t20");
            FpSpread1.Sheets[0].SetClip(2, 0, 1, 3, "Scott\tUSA\t5");
           

            FpSpread1.Sheets[0].Columns[0].Label = "Name";
            FpSpread1.Sheets[0].Columns[1].Label = "Country";
            FpSpread1.Sheets[0].Columns[2].Label = "Number";
            FpSpread1.EnableAjaxCall = false;
            FpSpread1.ActiveSheetView.AllowGroup = true;
            FpSpread1.ActiveSheetView.AllowColumnMove = true;
            FpSpread1.ActiveSheetView.GroupBarVisible = true;                      
        }
               
        //This code works when grouping is done either by the end user dynamically i.e. 
        //dragging columns to group bar or when the grouping is done through code behind 
        //as on a button click.
        private void CalculateGroups(object sender)
        {
            FarPoint.Web.Spread.FpSpread ss = (FarPoint.Web.Spread.FpSpread)sender;
            FarPoint.Web.Spread.Model.GroupDataModel gm;
            int total;
            int column = 0;
            int y = 0;
            gm = (FarPoint.Web.Spread.Model.GroupDataModel)ss.ActiveSheetView.DataModel;
 
            for (int i = 0; i < ss.ActiveSheetView.NonEmptyRowCount; i++)
            {
                if (gm.IsGroup(i))
                {
                    FarPoint.Web.Spread.Model.Group g;
                    g = gm.GetGroup(i);
                    g.Expanded = false;
                    total = 0;
 
                    total = g.Rows.Count;
                    column = g.Column;
 
                    string s = gm.TargetModel.GetValue(getRow(g), column).ToString();
                    s = column.ToString() + ":" + s;
                    g.Text = s + " (" + total.ToString() + ")";                    
                }
            }                 
        }

        int getRow(FarPoint.Web.Spread.Model.Group group)
        {
            if (group.Rows[0] is FarPoint.Web.Spread.Model.Group) return getRow(group.Rows[0] as FarPoint.Web.Spread.Model.Group);
            return (int)group.Rows[0];
        }


        protected void Button1_Click(object sender, EventArgs e)
        {
            FarPoint.Web.Spread.Model.GroupDataModel gm = new FarPoint.Web.Spread.Model.GroupDataModel(FpSpread1.ActiveSheetView.DataModel);
            FarPoint.Web.Spread.SortInfo[] sort1 = new FarPoint.Web.Spread.SortInfo[3];
            sort1[0] = new FarPoint.Web.Spread.SortInfo(0, true);
            sort1[1] = new FarPoint.Web.Spread.SortInfo(1, true);
            sort1[2] = new FarPoint.Web.Spread.SortInfo(2, true);
            gm.Group(sort1);
            
            FpSpread1.ActiveSheetView.DataModel = gm;
            CalculateGroups(FpSpread1);
        }

        protected void FpSpread1_Grouped(object sender, EventArgs e)
        {
            FarPoint.Web.Spread.FpSpread ss = (FarPoint.Web.Spread.FpSpread)sender;
            if (ss.ActiveSheetView.DataModel.GetType() == typeof(FarPoint.Web.Spread.Model.GroupDataModel))
            {
                CalculateGroups(sender);
            }
        }       
    }
}